package solutions.bitbadger.documents.core.tests.integration

import org.junit.jupiter.api.DisplayName
import kotlin.test.Test

/**
 * SQLite integration tests for the `Custom` object / `custom*` connection extension functions
 */
@DisplayName("Core | Kotlin | SQLite: Custom")
class SQLiteCustomIT {

    @Test
    @DisplayName("list succeeds with empty list")
    fun listEmpty() =
        SQLiteDB().use(CustomFunctions::listEmpty)

    @Test
    @DisplayName("list succeeds with a non-empty list")
    fun listAll() =
        SQLiteDB().use(CustomFunctions::listAll)

    @Test
    @DisplayName("single succeeds when document not found")
    fun singleNone() =
        SQLiteDB().use(CustomFunctions::singleNone)

    @Test
    @DisplayName("single succeeds when a document is found")
    fun singleOne() =
        SQLiteDB().use(CustomFunctions::singleOne)

    @Test
    @DisplayName("nonQuery makes changes")
    fun nonQueryChanges() =
        SQLiteDB().use(CustomFunctions::nonQueryChanges)

    @Test
    @DisplayName("nonQuery makes no changes when where clause matches nothing")
    fun nonQueryNoChanges() =
        SQLiteDB().use(CustomFunctions::nonQueryNoChanges)

    @Test
    @DisplayName("scalar succeeds")
    fun scalar() =
        SQLiteDB().use(CustomFunctions::scalar)
}
